package weka.filters.unsupervised.attribute;


import weka.core.*;
import weka.filters.SimpleBatchFilter;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

/**
 * A filter that processes images by computing histograms of RGB intensity values.
 *
 * The first attribute in the input data is required to be a string attribute with the file names of images.
 */
public class HistogramFilter extends SimpleBatchFilter {

  /**
   * The width of each bin in the histograms (i.e., the number of intensity values covered by a bin).
   */
  protected int m_binWidth = 10;

  /**
   * The method used to establish the format of the data generated by this filter, as an Instances object.
   *
   * @param data the input dataset, with a string attribute containing the file names of the images
   * @return an Instances object that provides the "header" information for the data generated by this filter
   * (i.e., an Instances object that does not contain any actual instances but does contain a list of attributes).
   */
  public Instances determineOutputFormat(Instances data) {

    if (m_Debug) {
      System.err.println("Determining output format.");
    }

    int numFeatures = 3 * ((256 % m_binWidth == 0) ? 256 / m_binWidth : 1 + 256 / m_binWidth);

    ArrayList<Attribute> atts = new ArrayList<>(numFeatures + 1);
    for (int i = 0; i < numFeatures; i++) {
      atts.add(new Attribute("x" + (i + 1)));
    }
    if (data.classIndex() > -1) {
      atts.add((Attribute) data.classAttribute().copy());
    }
    Instances output = new Instances("features", atts, 0);
    output.setClassIndex(output.numAttributes() - 1);
    if (m_Debug) {
      System.err.println("Finished determining output format with " + output.numAttributes() + " attributes.");
    }
    return output;

  }

  /**
   * The method that processes the given dataset and outputs the filtered data.
   *
   * @param data the input data to be filtered, with a string attribute containing the file names of the images
   * @return the filtered data, consisting of feature vectors ready for other machine learning algorithms
   */
  public Instances process(Instances data) throws Exception {

    // Get empty dataset that will hold the data
    Instances output = getOutputFormat();

    // Go through the data passed into this method and convert each image into a feature vector
    for (Instance inst : data) {

      // The array that will hold the feature values
      double[] featureVector = new double[output.numAttributes()];
      featureVector[output.classIndex()] = inst.classValue();

      // Read the current image and compute the features
      String fileName = inst.stringValue(0);
      BufferedImage img = null;
      try {
        img = ImageIO.read(new File(fileName));
        for (int j = 0; j < img.getWidth(); j++) {
          for (int k = 0; k < img.getHeight(); k++) {
            int rgb = img.getRGB(k, j);
            int r = (rgb >> 16) & 0xFF;
            int g = (rgb >> 8) & 0xFF;
            int b = (rgb & 0xFF);
            featureVector[r / m_binWidth]++;
            featureVector[(output.numAttributes() - 1) / 3 + g / m_binWidth]++;
            featureVector[2 * (output.numAttributes() - 1) / 3 + b / m_binWidth]++;
          }
        }

        // Make a WEKA instance and add it to the dataset we return from this method
        output.add(new DenseInstance(inst.weight(), featureVector));
      } catch (IOException e) {
        System.err.println("File " + fileName + " could not be read");
      }
    }

    return output;
  }

  /**
   * The info shown in the GUI.
   *
   * @return the info describing the filter.
   */
  public String globalInfo() {
    return "This filter calculates a feature vector using histograms of RBG intensity values.";
  }

  /**
   * The capabilities of this filter.
   *
   * @return the capabilities
   */
  public Capabilities getCapabilities() {
    Capabilities result = super.getCapabilities();
    result.enable(Capabilities.Capability.STRING_ATTRIBUTES);
    result.enableAllClasses();
    result.enable(Capabilities.Capability.MISSING_CLASS_VALUES);
    return result;
  }

  @OptionMetadata(
          displayName = "bin width",
          description = "The bin width (number of intensity values covered by a bin in one of the histograms).",
          displayOrder = 1,
          commandLineParamName = "B",
          commandLineParamSynopsis = "-B")
  public int getBinWidth() {
    return m_binWidth;
  }

  public void setBinWidth(int w) {
    this.m_binWidth = w;
  }

  /**
   * The main method used for running this filter from the command-line interface.
   *
   * @param options the command-line options
   */
  public static void main(String[] options) {
    runFilter(new HistogramFilter(), options);
  }
}